<script setup lang="ts">
import SystemInfoTable from '../SystemInfoTable/SystemInfoTable.vue';
import { ref, toRefs } from 'vue';
import type { PropType } from 'vue';
import { IOtherTab, IPCIETransformCard } from '../../product.datatype';
import { getBoard } from '../../service/system.service';
import { isOtherEmptyProperty } from '../../utils/system.util';

const props = defineProps({
  data: {
    type: Object as PropType<IOtherTab>,
    required: true,
    default: () => {
      return {};
    },
  },
});
const tableId = 'pCIETransformTable';
const { data } = toRefs(props);
const boardData: IOtherTab = data?.value;
const boardTableData = ref([] as any);
const boardShow = ref(false);

if (boardData.currentNumber && boardData.currentNumber > 0) {
  getBoard(boardData.detailLink).then((res: any) => {
    if (res.data && res.data.length > 0) {
      res.data.forEach((borad: any) => {
        const d = parseData(borad);
        if (d) {
          boardTableData.value.push(d);
        }
      });
    }
    boardShow.value = true; // 异步请求，等请求结束才能显示
  });
} else {
  boardShow.value = true; // 为了显示表头
}

function parseData(board: any): IPCIETransformCard {
  return {
    boardName: isOtherEmptyProperty(board.BoardName) || ' ',
    description: isOtherEmptyProperty(board.Description) || ' ',
    cardNo: isOtherEmptyProperty(board.CardNo) || 0,
    pCBVersion: isOtherEmptyProperty(board.PCBVersion) || ' ',
    boardId: isOtherEmptyProperty(board.BoardID) || ' ',
  };
}

const columns = [
  {
    title: 'COMMON_NAME',
    width: '20%',
    show: true,
    content: 'boardName',
  },
  {
    title: 'COMMON_DESCRIPTION',
    width: '38%',
    show: true,
    content: 'description',
  },
  {
    title: 'OTHER_SLOT_POSITION',
    width: '14%',
    show: true,
    content: 'cardNo',
  },
  {
    title: 'COMMON_ALARM_PCB_VERSION',
    width: '14%',
    show: true,
    content: 'pCBVersion',
  },
  {
    title: 'OTHER_BOARD_ID',
    width: '14%',
    show: true,
    content: 'boardId',
  },
];
</script>

<template>
  <SystemInfoTable
    v-if="boardShow"
    :id="tableId"
    :data="boardTableData"
    :columns="columns"
    :num="boardData.maxNumber"
  />
</template>

<style lang="scss" scoped></style>
